'use strict';

var server = require('server');

server.append('Landing', function(req, res, next) {
  res.setViewData({
    recaptchaUrl: 'https://www.google.com/recaptcha/api.js',
    siteKey: '6LeIxAcTAAAAAJcZVRqyHh71UMIEGNQ_MXjiZKhI' // Test Site Key from Google
  });

  next();
});

server.append('Subscribe', function(req, res, next) {
  // Token automatically added to request by recaptcha
  var token = req.form['g-recaptcha-response'];

  // Add required parameters for validation call
  var params = {
    // This is a test secret from Google
    // In practice, do not hardcode this. It's better to store
    // In a custom preference or service credential Configuration
    secret: '6LeIxAcTAAAAAGG-vFI1TnRWxMZNFuojJ4WifJWe', // Test secret key from Google
    response: token
  };

  // Calls recaptcha service
  // Returns a Service class instance
  var validationResult = recaptchaService.call(params);

  // Actual response from Google
  var response = verificationResult.object;

  if (!response.success) {
    // Handle failure by returning error to the client
    res.json({
      success: false,
      msg: 'Recaptcha Validation Failure'
    });
  }

  next();
});

module.exports = server.exports();